<?php

namespace Teknisa\CTB\Factories;

use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;

class Ctb17000RelatorioRazaoContrapartidaFactory {

    protected $entityManager;

    /**
     * @param EntityManager $entityManager
     */
    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }
    
    /**
     * Executa Procedure RAZAO_OFICIAL
     * @param $cdempresa
     * @param $cdcontini
     * @param $cdcontfin
     * @param $dtinicial
     * @param $dtfinal
     * @param $relesp
     * @return mixed
     */
    public function execProcRazaoOficial(
        $cdempresa, $cdcontini, $cdcontfin, $dtinicial, $dtfinal, $relesp
    ){
        $procedure = new StoredProcedure($this->entityManager->getConnection(), 'RAZAO_OFICIAL');
        $procedure->addParam(new Param('P_CDEMPRESA' , Param::PARAM_INPUT , $cdempresa , Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDCONTINI' , Param::PARAM_INPUT , $cdcontini , Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDCONTFIN' , Param::PARAM_INPUT , $cdcontfin , Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTINICIAL' , Param::PARAM_INPUT , $dtinicial , Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTFINAL'   , Param::PARAM_INPUT , $dtfinal   , Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_RELESP'    , Param::PARAM_INPUT , $relesp    , Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRRAZAO'   , Param::PARAM_OUTPUT, null       , Param::PARAM_TYPE_STR, 50));
        $nrrazao = $procedure->execute();

        return $nrrazao['P_NRRAZAO'];
    }
}