<?php

namespace Teknisa\CTB\Services;

use Teknisa\CTB\Factories\Ctb17000ImplantacaoSaldoFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;

class Ctb17000ImplantacaoSaldoService {

    protected $entityManager;
    protected $environment;
    protected $nrorg;

    public function __construct(\Doctrine\ORM\EntityManager $entityManager, Environment $environment, NewCode $newCode, Ctb17000ImplantacaoSaldoFactory $factory) {
        $this->entityManager = $entityManager;
        $this->environment = $environment;
        $this->nrorg = $environment->getNrorgTrab();
        $this->newCode = $newCode;
        $this->factory = $factory;
    }

    public function getSequencial(){
        $sequencial = $this->newCode->getCodeByTableName("IMPLANTACAOSALDO", $this->nrorg, 1, 12);
        $sequencial = intval($sequencial);
        return $sequencial;
    }

    public function getVdImplantSaldo($row){
        $result = $this->factory->getVdImplantSaldo(array(
            "P_CDEMPRESA" => $row['CDEMPRESA'],
            "P_CDCONTCTBL" => $row['CDCONTCTBL'],
            "P_DTIMPSALDO" => $row['DTIMPSALDO'],
            "P_NRORG" => $this->nrorg));
        if (!empty($result) && $row['__is_new']){
            throw new \Exception("JA_CADASTRADO", 1);
        }
    }
    
    public function Update($row){
        $result = $this->factory->Update(array(
            "CDCONTCTBL" => $row['CDCONTCTBL'],
            "VRIMPSALDO" => $row['VRIMPSALDO'],
            "OLD_NRIMPLSALDO" => $row['NRIMPLSALDO']));
    }
}
